"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Cognito = void 0;
var _react = _interopRequireWildcard(require("react"));
var _appAdmin = require("@webiny/app-admin");
var _plugins = require("@webiny/plugins");
var _appSecurity = require("@webiny/app-security");
var _constants = require("./plugins/constants");
var _UsersView = require("./ui/views/Users/UsersView");
var _Account = require("./ui/views/Account");
var _userInfo = require("./plugins/userMenu/userInfo");
var _accountDetails = require("./plugins/userMenu/accountDetails");
var _signOut = require("./plugins/userMenu/signOut");
var _installation = _interopRequireDefault(require("./plugins/installation"));
var _permissionRenderer = _interopRequireDefault(require("./plugins/permissionRenderer"));
var _cognito = _interopRequireDefault(require("./plugins/cognito"));
var _CognitoLogin = require("./CognitoLogin");
var ACCOUNT_ROUTE = "/account";
var CognitoIdP = function CognitoIdP(props) {
  _plugins.plugins.register([_installation.default, _permissionRenderer.default, (0, _cognito.default)()]);
  return /*#__PURE__*/_react.default.createElement(_react.Fragment, null, /*#__PURE__*/_react.default.createElement(_CognitoLogin.CognitoLogin, {
    config: props.config,
    userMenuItems: {
      userInfo: false,
      signOut: false
    }
  }), /*#__PURE__*/_react.default.createElement(_appAdmin.Plugin, null, /*#__PURE__*/_react.default.createElement(_appSecurity.HasPermission, {
    name: _constants.Permission.Users
  }, /*#__PURE__*/_react.default.createElement(_appAdmin.AddRoute, {
    path: "/admin-users"
  }, /*#__PURE__*/_react.default.createElement(_appAdmin.Layout, {
    title: "Admin Users"
  }, /*#__PURE__*/_react.default.createElement(_UsersView.UsersView, null))), /*#__PURE__*/_react.default.createElement(_appAdmin.AddMenu, {
    name: "settings"
  }, /*#__PURE__*/_react.default.createElement(_appAdmin.AddMenu, {
    name: "cognito.adminUsers",
    label: "Admin Users"
  }, /*#__PURE__*/_react.default.createElement(_appAdmin.AddMenu, {
    name: "cognito.adminUsers.users",
    label: "Users",
    path: "/admin-users"
  })))), /*#__PURE__*/_react.default.createElement(_appAdmin.AddRoute, {
    path: ACCOUNT_ROUTE
  }, /*#__PURE__*/_react.default.createElement(_appAdmin.Layout, {
    title: "User Account"
  }, /*#__PURE__*/_react.default.createElement(_Account.Account, null))), /*#__PURE__*/_react.default.createElement(_appAdmin.AddUserMenuItem, {
    element: /*#__PURE__*/_react.default.createElement(_userInfo.UserInfo, {
      accountRoute: ACCOUNT_ROUTE
    })
  }), /*#__PURE__*/_react.default.createElement(_appAdmin.AddUserMenuItem, {
    element: /*#__PURE__*/_react.default.createElement(_accountDetails.AccountDetails, {
      accountRoute: ACCOUNT_ROUTE
    })
  }), /*#__PURE__*/_react.default.createElement(_appAdmin.AddUserMenuItem, {
    element: /*#__PURE__*/_react.default.createElement(_signOut.SignOut, null)
  })));
};
var Cognito = exports.Cognito = /*#__PURE__*/(0, _react.memo)(CognitoIdP);

//# sourceMappingURL=Cognito.js.map