"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CognitoLogin = void 0;
var _react = _interopRequireWildcard(require("react"));
var _createAuthentication = require("./createAuthentication");
var _appAdmin = require("@webiny/app-admin");
var _userInfo = require("./plugins/userMenu/userInfo");
var _signOut = require("./plugins/userMenu/signOut");
var createLoginScreenDecorator = function createLoginScreenDecorator(config) {
  var LoginComponent = (0, _createAuthentication.createAuthentication)(config);
  return _appAdmin.LoginScreenRenderer.createDecorator(function () {
    return function LoginScreen(_ref) {
      var children = _ref.children;
      return /*#__PURE__*/_react.default.createElement(LoginComponent, null, children);
    };
  });
};
var CognitoLogin = exports.CognitoLogin = function CognitoLogin(_ref2) {
  var userMenuItems = _ref2.userMenuItems,
    config = _ref2.config;
  var LoginScreenDecorator = (0, _react.useMemo)(function () {
    return createLoginScreenDecorator(config);
  }, []);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(LoginScreenDecorator, null), userMenuItems ? /*#__PURE__*/_react.default.createElement(_appAdmin.Plugin, null, userMenuItems.userInfo ? /*#__PURE__*/_react.default.createElement(_appAdmin.AddUserMenuItem, {
    element: /*#__PURE__*/_react.default.createElement(_userInfo.UserInfo, null)
  }) : null, userMenuItems.signOut ? /*#__PURE__*/_react.default.createElement(_appAdmin.AddUserMenuItem, {
    element: /*#__PURE__*/_react.default.createElement(_signOut.SignOut, null)
  }) : null) : null);
};

//# sourceMappingURL=CognitoLogin.js.map