import React from "react";
import { DocumentNode } from "graphql";
import { AuthenticationFactoryConfig as BaseConfig } from "@webiny/app-admin-cognito";
import { GetIdentityDataCallable } from "../createGetIdentityData/createGetIdentityData";
export interface CreateAuthenticationConfig extends Partial<BaseConfig> {
    loginMutation?: DocumentNode;
}
interface WithGetIdentityDataProps {
    getIdentityData: GetIdentityDataCallable;
    children: React.ReactNode;
}
export declare const createAuthentication: (config?: CreateAuthenticationConfig) => ({ children }: Omit<WithGetIdentityDataProps, "getIdentityData">) => React.JSX.Element;
export {};
