"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createAuthentication = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _appAdminCognito = require("@webiny/app-admin-cognito");
var _appAdmin = require("@webiny/app-admin");
var _appTenancy = require("@webiny/app-tenancy");
var _NotAuthorizedError = require("./NotAuthorizedError");
var _createGetIdentityData = require("../createGetIdentityData");
var createAuthentication = exports.createAuthentication = function createAuthentication() {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var withGetIdentityData = function withGetIdentityData(Component) {
    var WithGetIdentityData = function WithGetIdentityData(_ref) {
      var children = _ref.children;
      var _useTenancy = (0, _appTenancy.useTenancy)(),
        isMultiTenant = _useTenancy.isMultiTenant;
      var loginMutation = config.loginMutation || (isMultiTenant ? _createGetIdentityData.LOGIN_MT : _createGetIdentityData.LOGIN_ST);
      var getIdentityData = config.getIdentityData || (0, _createGetIdentityData.createGetIdentityData)(loginMutation);
      /**
       * TODO @ts-refactor
       * createGetIdentityData return function does not have payload param so TS is complaining.
       * createGetIdentityData does not need the payload param
       */
      // @ts-expect-error
      return /*#__PURE__*/_react.default.createElement(Component, {
        getIdentityData: getIdentityData
      }, children);
    };
    return WithGetIdentityData;
  };
  var Authentication = function Authentication(_ref2) {
    var getIdentityData = _ref2.getIdentityData,
      children = _ref2.children;
    var _useTags = (0, _appAdmin.useTags)(),
      installer = _useTags.installer;
    var _useState = (0, _react.useState)(null),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      error = _useState2[0],
      setError = _useState2[1];
    var BaseAuthentication = (0, _react.useMemo)(function () {
      return (0, _appAdminCognito.createAuthentication)((0, _objectSpread2.default)({
        onError: function onError(error) {
          setError(error.message);
        },
        getIdentityData: getIdentityData
      }, config));
    }, []);
    if (error && !installer) {
      return /*#__PURE__*/_react.default.createElement(_NotAuthorizedError.NotAuthorizedError, null);
    }
    return /*#__PURE__*/_react.default.createElement(BaseAuthentication, null, children);
  };
  return withGetIdentityData((0, _appTenancy.withTenant)(Authentication));
};

//# sourceMappingURL=createAuthentication.js.map