"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createPasswordValidator = void 0;
var _validation = require("@webiny/validation");
var createPasswordValidator = exports.createPasswordValidator = function createPasswordValidator(policy) {
  return function (value) {
    if (!value) {
      return;
    }
    /**
     * TODO @ts-refactor
     * @pavel expl
     */
    value = value + "";
    var requireSymbols = /([=+\-^$*.\[\]{}()?"!@#%&/,><':;|_~`])+/;
    var requireNumber = /[0-9]/;
    var requireLowercase = /[a-z]/;
    var requireUppercase = /[A-Z]/;
    if (policy.minimumLength !== undefined && value.length < policy.minimumLength) {
      throw new _validation.ValidationError("Value requires at least ".concat(policy.minimumLength, " characters."));
    }
    if (policy.requireLowercase && !requireLowercase.test(value)) {
      throw new _validation.ValidationError("Value must contain a lowercase character.");
    }
    if (policy.requireNumbers && !requireNumber.test(value)) {
      throw new _validation.ValidationError("Value must contain a number.");
    }
    if (policy.requireUppercase && !requireUppercase.test(value)) {
      throw new _validation.ValidationError("Value must contain an uppercase character.");
    }
    if (policy.requireSymbols && !requireSymbols.test(value)) {
      throw new _validation.ValidationError("Value must contain a special character.");
    }
  };
};

//# sourceMappingURL=createPasswordValidator.js.map