"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _Grid = require("@webiny/ui/Grid");
var _Input = require("@webiny/ui/Input");
var _validation = require("@webiny/validation");
var _ViewPlugin = require("@webiny/app/plugins/ViewPlugin");
var _UIView = require("@webiny/app-admin/ui/UIView");
var _UsersFormView = require("../ui/views/Users/UsersFormView");
var _PasswordElement = require("@webiny/app-admin/ui/elements/form/PasswordElement");
var _createPasswordValidator = require("../createPasswordValidator");
var _config = require("@webiny/app/config");
var _default = exports.default = function _default() {
  var envPasswordValidatorPolicy;
  try {
    envPasswordValidatorPolicy = JSON.parse(process.env.REACT_APP_USER_POOL_PASSWORD_POLICY);
  } catch (_unused) {
    // Do nothing.
  }
  var passwordValidatorPolicy = _config.config.getKey("USER_POOL_PASSWORD_POLICY", envPasswordValidatorPolicy);
  var passwordValidator = (0, _createPasswordValidator.createPasswordValidator)(passwordValidatorPolicy);
  return [
  // Add password input to admin user installation
  new _ViewPlugin.ViewPlugin({
    name: "adminUsers.installation.fields",
    render: function render(_ref) {
      var children = _ref.children,
        Bind = _ref.Bind;
      return /*#__PURE__*/_react.default.createElement(_react.Fragment, null, children, /*#__PURE__*/_react.default.createElement(_Grid.Cell, {
        span: 12
      }, /*#__PURE__*/_react.default.createElement(Bind, {
        name: "password",
        validators: [passwordValidator, _validation.validation.create("required")]
      }, /*#__PURE__*/_react.default.createElement(_Input.Input, {
        autoComplete: "off",
        type: "password",
        label: "Password"
      }))));
    }
  }),
  // Add password input to admin user form
  new _ViewPlugin.ViewPlugin({
    name: "adminUsers.account.form.fields",
    render: function render(_ref2) {
      var children = _ref2.children,
        Bind = _ref2.Bind,
        data = _ref2.data;
      return /*#__PURE__*/_react.default.createElement(_react.Fragment, null, children, /*#__PURE__*/_react.default.createElement(_Grid.Cell, {
        span: 12
      }, /*#__PURE__*/_react.default.createElement(Bind, {
        name: "password",
        validators: passwordValidator
      }, /*#__PURE__*/_react.default.createElement(_Input.Input, {
        autoComplete: "off",
        disabled: data.external,
        description: data.id && "Type a new password to reset it.",
        type: "password",
        label: "Password",
        "data-testid": "account.password"
      }))));
    }
  }),
  // Add password input to admin user form
  new _UIView.UIViewPlugin(_UsersFormView.UsersFormView, function (view) {
    var bioSection = view.getElement("bio");
    if (!bioSection) {
      return;
    }
    var useFormHook = function useFormHook() {
      return view.getUserFormHook();
    };
    bioSection.addElement(new _PasswordElement.PasswordElement("password", {
      name: "password",
      label: "Password",
      description: function description() {
        var _useFormHook = useFormHook(),
          isNewUser = _useFormHook.isNewUser;
        if (!isNewUser) {
          return "Type a new password to reset it.";
        }
        return "";
      },
      validators: function validators() {
        var _useFormHook2 = useFormHook(),
          isNewUser = _useFormHook2.isNewUser;
        if (isNewUser) {
          return [passwordValidator, _validation.validation.create("required")];
        }
        return passwordValidator;
      }
    }));
  })];
};

//# sourceMappingURL=cognito.js.map