"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));
var _graphqlTag = _interopRequireDefault(require("graphql-tag"));
var _emotion = require("emotion");
var _react = _interopRequireWildcard(require("react"));
var _reactHooks = require("@apollo/react-hooks");
var _form = require("@webiny/form");
var _Alert = require("@webiny/ui/Alert");
var _Button = require("@webiny/ui/Button");
var _Input = require("@webiny/ui/Input");
var _Checkbox = require("@webiny/ui/Checkbox");
var _Grid = require("@webiny/ui/Grid");
var _Progress = require("@webiny/ui/Progress");
var _validation = require("@webiny/validation");
var _SimpleForm = require("@webiny/app-admin/components/SimpleForm");
var _View = require("@webiny/app/components/View");
var _excluded = ["subscribed"];
var _templateObject, _templateObject2, _templateObject3;
var removeGridPadding = (0, _emotion.css)(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["\n    > .mdc-layout-grid {\n        padding: 0;\n    }\n"])));
var IS_INSTALLED = (0, _graphqlTag.default)(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2.default)(["\n    query IsAdminUsersInstalled {\n        adminUsers {\n            version\n        }\n    }\n"])));
var INSTALL = (0, _graphqlTag.default)(_templateObject3 || (_templateObject3 = (0, _taggedTemplateLiteral2.default)(["\n    mutation InstallAdminUsers($data: AdminUsersInstallInput) {\n        adminUsers {\n            install(data: $data) {\n                data\n                error {\n                    code\n                    message\n                }\n            }\n        }\n    }\n"])));
var Install = function Install(_ref) {
  var onInstalled = _ref.onInstalled;
  var client = (0, _reactHooks.useApolloClient)();
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    loading = _useState2[0],
    setLoading = _useState2[1];
  var _useState3 = (0, _react.useState)(null),
    _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
    error = _useState4[0],
    setError = _useState4[1];
  var onSubmit = (0, _react.useCallback)(async function (_ref2) {
    var subscribed = _ref2.subscribed,
      form = (0, _objectWithoutProperties2.default)(_ref2, _excluded);
    setLoading(true);
    setError(null);
    var _await$client$mutate = await client.mutate({
        mutation: INSTALL,
        variables: {
          data: form
        }
      }),
      res = _await$client$mutate.data;
    setLoading(false);
    var error = res.adminUsers.install.error;
    if (error) {
      switch (error.code) {
        case "COGNITO_ACCOUNT_EXISTS":
          setError("An account with this email already exists.");
          break;
        default:
          setError(error.message);
      }
      return;
    }
    if (subscribed) {
      try {
        await fetch("https://app.mailerlite.com/webforms/submit/g9f1i1?fields%5Bemail%5D=" + encodeURIComponent(form.email) + "&ml-submit=1&ajax=1", {
          method: "GET",
          headers: {
            "Content-Type": "application/x-www-form-urlencoded"
          }
        });
      } catch (err) {
        setError("Unable to subscribe you to the newsletter " + err);
      }
    }
    onInstalled();
  }, []);
  var privacyPolicyLink = /*#__PURE__*/_react.default.createElement("a", {
    href: "https://www.webiny.com/privacy-policy"
  }, "privacy policy");
  return /*#__PURE__*/_react.default.createElement(_form.Form, {
    onSubmit: onSubmit,
    submitOnEnter: true
  }, function (_ref3) {
    var data = _ref3.data,
      Bind = _ref3.Bind,
      submit = _ref3.submit;
    return /*#__PURE__*/_react.default.createElement(_SimpleForm.SimpleForm, null, loading && /*#__PURE__*/_react.default.createElement(_Progress.CircularProgress, null), /*#__PURE__*/_react.default.createElement(_SimpleForm.SimpleFormHeader, {
      title: "Create an Admin User"
    }), /*#__PURE__*/_react.default.createElement(_SimpleForm.SimpleFormContent, null, /*#__PURE__*/_react.default.createElement(_Grid.Grid, null, error && /*#__PURE__*/_react.default.createElement(_Grid.Cell, {
      span: 12
    }, /*#__PURE__*/_react.default.createElement(_Alert.Alert, {
      title: "Something went wrong",
      type: "danger"
    }, error)), /*#__PURE__*/_react.default.createElement(_Grid.Cell, {
      span: 12
    }, "Let's create your admin user:"), /*#__PURE__*/_react.default.createElement(_Grid.Cell, {
      span: 12
    }, /*#__PURE__*/_react.default.createElement(Bind, {
      name: "firstName",
      validators: _validation.validation.create("required,minLength:2")
    }, /*#__PURE__*/_react.default.createElement(_Input.Input, {
      label: "First Name"
    }))), /*#__PURE__*/_react.default.createElement(_Grid.Cell, {
      span: 12
    }, /*#__PURE__*/_react.default.createElement(Bind, {
      name: "lastName",
      validators: _validation.validation.create("required,minLength:2")
    }, /*#__PURE__*/_react.default.createElement(_Input.Input, {
      label: "Last Name"
    }))), /*#__PURE__*/_react.default.createElement(_Grid.Cell, {
      span: 12
    }, /*#__PURE__*/_react.default.createElement(Bind, {
      name: "email",
      validators: _validation.validation.create("required,email"),
      beforeChange: function beforeChange(value, cb) {
        return cb(value.toLowerCase());
      }
    }, /*#__PURE__*/_react.default.createElement(_Input.Input, {
      label: "Email"
    }))), /*#__PURE__*/_react.default.createElement(_View.View, {
      name: "adminUsers.installation.fields",
      props: {
        Bind: Bind,
        data: data
      }
    })), /*#__PURE__*/_react.default.createElement(_Grid.Grid, {
      style: {
        paddingTop: "0px"
      }
    }, /*#__PURE__*/_react.default.createElement(_Grid.Cell, {
      span: 12
    }, /*#__PURE__*/_react.default.createElement(Bind, {
      name: "subscribed"
    }, /*#__PURE__*/_react.default.createElement(_Checkbox.Checkbox, {
      label: "I want to receive updates on product improvements and new features."
    }))))), /*#__PURE__*/_react.default.createElement(_SimpleForm.SimpleFormFooter, {
      className: removeGridPadding
    }, /*#__PURE__*/_react.default.createElement(_Grid.Grid, null, /*#__PURE__*/_react.default.createElement(_Grid.Cell, {
      span: 8
    }, /*#__PURE__*/_react.default.createElement("p", {
      style: {
        textAlign: "left"
      }
    }, "By submitting the form, you agree to our Terms of Service and acknowledge our ", privacyPolicyLink, ".")), /*#__PURE__*/_react.default.createElement(_Grid.Cell, {
      span: 4
    }, /*#__PURE__*/_react.default.createElement(_Button.ButtonPrimary, {
      "data-testid": "install-security-button",
      onClick: function onClick() {
        submit();
      }
    }, "Create Admin User")))));
  });
};
var installationPlugin = {
  name: "admin-installation-admin-users",
  type: "admin-installation",
  dependencies: ["admin-installation-security"],
  secure: false,
  title: "Admin User",
  getInstalledVersion: async function getInstalledVersion(_ref4) {
    var client = _ref4.client;
    var _await$client$query = await client.query({
        query: IS_INSTALLED
      }),
      data = _await$client$query.data;
    return data.adminUsers.version;
  },
  render: function render(_ref5) {
    var onInstalled = _ref5.onInstalled;
    return /*#__PURE__*/_react.default.createElement(Install, {
      onInstalled: onInstalled
    });
  }
};
var _default = exports.default = [installationPlugin];

//# sourceMappingURL=installation.js.map