"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.AccountDetails = void 0;
var _react = _interopRequireDefault(require("react"));
var _emotion = require("emotion");
var _List = require("@webiny/ui/List");
var _Icon = require("@webiny/ui/Icon");
var _reactRouter = require("@webiny/react-router");
var _roundAccount_circle24px = require("../../assets/icons/round-account_circle-24px.svg");
var _logout_black_24dp = require("../../assets/icons/logout_black_24dp.svg");
var _appSecurity = require("@webiny/app-security");
var _appTenancy = require("@webiny/app-tenancy");
var _useIsDefaultTenant = require("./useIsDefaultTenant");
var linkStyles = (0, _emotion.css)({
  "&:hover": {
    textDecoration: "none"
  }
});
var AccountDetails = exports.AccountDetails = function AccountDetails(_ref) {
  var accountRoute = _ref.accountRoute;
  var security = (0, _appSecurity.useSecurity)();
  var tenancy = (0, _appTenancy.useTenancy)();
  var isDefaultTenant = (0, _useIsDefaultTenant.useIsDefaultTenant)();
  if (!security || !security.identity) {
    return null;
  }

  // This is only applicable in multi-tenant environments
  var defaultTenant = security.identity.defaultTenant;
  if (tenancy && !isDefaultTenant) {
    return /*#__PURE__*/_react.default.createElement(_List.ListItem, {
      onClick: function onClick() {
        return tenancy.setTenant(defaultTenant.id);
      }
    }, /*#__PURE__*/_react.default.createElement(_List.ListItemGraphic, null, /*#__PURE__*/_react.default.createElement(_Icon.Icon, {
      icon: /*#__PURE__*/_react.default.createElement(_logout_black_24dp.ReactComponent, null)
    })), "Exit tenant");
  }
  if (!security.identity.profile) {
    return null;
  }
  return /*#__PURE__*/_react.default.createElement(_reactRouter.Link, {
    to: accountRoute,
    className: linkStyles
  }, /*#__PURE__*/_react.default.createElement(_List.ListItem, null, /*#__PURE__*/_react.default.createElement(_List.ListItemGraphic, null, /*#__PURE__*/_react.default.createElement(_Icon.Icon, {
    icon: /*#__PURE__*/_react.default.createElement(_roundAccount_circle24px.ReactComponent, null)
  })), "Account details"));
};
var _default = exports.default = function _default() {
  console.log("[DEPRECATED] Import \"@webiny/app-admin-users-cognito/plugins/userMenu/accountDetails\" is no longer used!");
  return {
    type: "dummy"
  };
};

//# sourceMappingURL=accountDetails.js.map