"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useIsDefaultTenant = useIsDefaultTenant;
var _appSecurity = require("@webiny/app-security");
function useIsDefaultTenant() {
  var security = (0, _appSecurity.useSecurity)();
  if (!security || !security.identity) {
    return false;
  }

  // This is only applicable in multi-tenant environments
  var _security$identity = security.identity,
    currentTenant = _security$identity.currentTenant,
    defaultTenant = _security$identity.defaultTenant;
  if (!currentTenant || !defaultTenant) {
    // If there's no tenant information, we assume this is a single-tenant environment.
    return true;
  }
  return currentTenant && defaultTenant && currentTenant.id === defaultTenant.id;
}

//# sourceMappingURL=useIsDefaultTenant.js.map