"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _omit = _interopRequireDefault(require("lodash/omit"));
var _reactHooks = require("@apollo/react-hooks");
var _i18n = require("@webiny/app/i18n");
var _form = require("@webiny/form");
var _Input = require("@webiny/ui/Input");
var _Button = require("@webiny/ui/Button");
var _Progress = require("@webiny/ui/Progress");
var _Snackbar = require("@webiny/ui/Snackbar");
var _Grid = require("@webiny/ui/Grid");
var _validation = require("@webiny/validation");
var _AvatarImage = _interopRequireDefault(require("../../components/AvatarImage"));
var _graphql = require("./graphql");
var _config = require("@webiny/app/config");
var _SimpleForm = require("@webiny/app-admin/components/SimpleForm");
var _appSecurity = require("@webiny/app-security");
var _View = require("@webiny/app/components/View");
var _appAdmin = require("@webiny/app-admin");
var _Alert = require("@webiny/ui/Alert");
var _templateObject, _templateObject2, _templateObject3, _templateObject4;
var t = _i18n.i18n.ns("app-security-admin-users/account-form");
var UserAccountForm = function UserAccountForm() {
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    loading = _useState2[0],
    setLoading = _useState2[1];
  var _useSnackbar = (0, _appAdmin.useSnackbar)(),
    showSnackbar = _useSnackbar.showSnackbar;
  var _useSecurity = (0, _appSecurity.useSecurity)(),
    setIdentity = _useSecurity.setIdentity;
  var currentUser = (0, _reactHooks.useQuery)(_graphql.GET_CURRENT_USER);
  var _useMutation = (0, _reactHooks.useMutation)(_graphql.UPDATE_CURRENT_USER),
    _useMutation2 = (0, _slicedToArray2.default)(_useMutation, 1),
    updateUser = _useMutation2[0];
  var _onSubmit = async function onSubmit(formData) {
    setLoading(true);
    var _await$updateUser = await updateUser({
        variables: {
          data: (0, _omit.default)(formData, ["id", "external"])
        }
      }),
      response = _await$updateUser.data;
    var error = response.adminUsers.updateCurrentUser.error;
    setLoading(false);
    if (error) {
      return showSnackbar(error.message, {
        action: /*#__PURE__*/_react.default.createElement(_Snackbar.SnackbarAction, {
          label: "Close",
          onClick: function onClick() {
            return showSnackbar(null);
          }
        })
      });
    }
    setIdentity(function (identity) {
      return (0, _objectSpread2.default)((0, _objectSpread2.default)({}, identity || {}), {}, {
        displayName: "".concat(formData.firstName, " ").concat(formData.lastName),
        profile: (0, _objectSpread2.default)((0, _objectSpread2.default)({}, identity?.profile || {}), {}, {
          firstName: formData.firstName,
          lastName: formData.lastName,
          avatar: formData.avatar
        })
      });
    });
    showSnackbar("Account saved successfully!");
  };
  var user = currentUser.loading ? {} : currentUser.data.adminUsers.user.data;
  var emailIsDisabled = _config.config.getKey("ADMIN_USER_CAN_CHANGE_EMAIL", process.env.REACT_APP_ADMIN_USER_CAN_CHANGE_EMAIL === "false");
  var isExternal = user?.external === true;
  return /*#__PURE__*/_react.default.createElement(_appAdmin.CenteredView, {
    maxWidth: 600
  }, /*#__PURE__*/_react.default.createElement(_form.Form, {
    data: user,
    onSubmit: function onSubmit(data) {
      /**
       * We are positive that data is UserAccountFormData.
       */
      _onSubmit(data);
    }
  }, function (_ref) {
    var data = _ref.data,
      form = _ref.form,
      Bind = _ref.Bind;
    return /*#__PURE__*/_react.default.createElement(_SimpleForm.SimpleForm, null, loading && /*#__PURE__*/_react.default.createElement(_Progress.CircularProgress, {
      style: {
        zIndex: 3
      }
    }), /*#__PURE__*/_react.default.createElement(_SimpleForm.SimpleFormHeader, {
      title: "Account"
    }), /*#__PURE__*/_react.default.createElement(_SimpleForm.SimpleFormContent, null, isExternal && /*#__PURE__*/_react.default.createElement(_Grid.Grid, null, /*#__PURE__*/_react.default.createElement(_Grid.Cell, {
      span: 12
    }, /*#__PURE__*/_react.default.createElement(_Alert.Alert, {
      type: "info",
      title: "External User"
    }, "This user is an external user and cannot be edited."))), /*#__PURE__*/_react.default.createElement(_Grid.Grid, null, /*#__PURE__*/_react.default.createElement(_Grid.Cell, {
      span: 12,
      "data-testid": "avatar"
    }, /*#__PURE__*/_react.default.createElement(Bind, {
      name: "avatar"
    }, /*#__PURE__*/_react.default.createElement(_AvatarImage.default, {
      round: true,
      disabled: isExternal
    }))), /*#__PURE__*/_react.default.createElement(_Grid.Cell, {
      span: 12
    }, /*#__PURE__*/_react.default.createElement(Bind, {
      name: "firstName",
      validators: _validation.validation.create("required")
    }, /*#__PURE__*/_react.default.createElement(_Input.Input, {
      label: t(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["First Name"]))),
      disabled: isExternal,
      "data-testid": "account.firstname"
    }))), /*#__PURE__*/_react.default.createElement(_Grid.Cell, {
      span: 12
    }, " ", /*#__PURE__*/_react.default.createElement(Bind, {
      name: "lastName",
      validators: _validation.validation.create("required")
    }, /*#__PURE__*/_react.default.createElement(_Input.Input, {
      label: t(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2.default)(["Last Name"]))),
      disabled: isExternal,
      "data-testid": "account.lastname"
    }))), /*#__PURE__*/_react.default.createElement(_Grid.Cell, {
      span: 12
    }, /*#__PURE__*/_react.default.createElement(Bind, {
      name: "email",
      validators: _validation.validation.create("required,email")
    }, /*#__PURE__*/_react.default.createElement(_Input.Input, {
      value: data.email,
      label: t(_templateObject3 || (_templateObject3 = (0, _taggedTemplateLiteral2.default)(["Email"]))),
      disabled: emailIsDisabled || isExternal,
      "data-testid": "account.email",
      description: "Email is your unique identifier used to login!"
    }))), /*#__PURE__*/_react.default.createElement(_View.View, {
      name: "adminUsers.account.form.fields",
      props: {
        Bind: Bind,
        data: data
      }
    }))), /*#__PURE__*/_react.default.createElement(_SimpleForm.SimpleFormFooter, {
      "data-testid": "form-footer"
    }, /*#__PURE__*/_react.default.createElement(_Button.ButtonPrimary, {
      disabled: isExternal,
      "data-testid": "account.updatebutton",
      onClick: function onClick(ev) {
        form.submit(ev);
      }
    }, t(_templateObject4 || (_templateObject4 = (0, _taggedTemplateLiteral2.default)(["Update account"]))))));
  }));
};
var _default = exports.default = UserAccountForm;

//# sourceMappingURL=Account.js.map