"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DeleteAction = void 0;
var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));
var _react = _interopRequireDefault(require("react"));
var _i18n = require("@webiny/app/i18n");
var _Tooltip = require("@webiny/ui/Tooltip");
var _icons = require("@webiny/ui/List/DataList/icons");
var _appSecurity = require("@webiny/app-security");
var _templateObject, _templateObject2;
var t = _i18n.i18n.ns("app-identity/admin/users/data-list");
var DeleteAction = exports.DeleteAction = function DeleteAction(_ref) {
  var item = _ref.item,
    onClick = _ref.onClick;
  var _useSecurity = (0, _appSecurity.useSecurity)(),
    identity = _useSecurity.identity;
  if (!identity) {
    return null;
  }
  if (identity.id === item.id) {
    return /*#__PURE__*/_react.default.createElement(_Tooltip.Tooltip, {
      placement: "bottom",
      content: /*#__PURE__*/_react.default.createElement("span", null, t(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["You can't delete your own user account."]))))
    }, /*#__PURE__*/_react.default.createElement(_icons.DeleteIcon, {
      disabled: true
    }));
  }
  if (item.external) {
    return /*#__PURE__*/_react.default.createElement(_Tooltip.Tooltip, {
      placement: "bottom",
      content: /*#__PURE__*/_react.default.createElement("span", null, t(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2.default)(["You can't delete external users."]))))
    }, /*#__PURE__*/_react.default.createElement(_icons.DeleteIcon, {
      disabled: true
    }));
  }
  return /*#__PURE__*/_react.default.createElement(_icons.DeleteIcon, {
    onClick: onClick,
    "data-testid": "default-data-list.delete"
  });
};

//# sourceMappingURL=DeleteAction.js.map