"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UPDATE_USER = exports.READ_USER = exports.LIST_USERS = exports.DELETE_USER = exports.CREATE_USER = void 0;
var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));
var _graphqlTag = _interopRequireDefault(require("graphql-tag"));
var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5;
var listUserFields = /* GraphQL */"\n    {\n        id\n        email\n        firstName\n        lastName\n        avatar\n        gravatar\n        createdOn\n        external\n    }\n";
var userFormFields = function userFormFields(params) {
  var gql = /* GraphQL */"\n        {\n            id\n            email\n            firstName\n            lastName\n            avatar\n            external\n            groups {\n                id\n                slug\n                name\n            }\n            TEAM\n        }\n    ";
  return gql.replace("TEAM", params.teams ? "teams {\n                id\n                slug\n                name\n            }" : "");
};
var LIST_USERS = exports.LIST_USERS = (0, _graphqlTag.default)(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["\n    query ListUsers {\n        adminUsers {\n            users: listUsers {\n                data ", "\n            }\n        }\n    }\n"])), listUserFields);
var READ_USER = exports.READ_USER = function READ_USER(params) {
  return (0, _graphqlTag.default)(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2.default)(["\n    query GetUser($id: ID!) {\n        adminUsers {\n            user: getUser(where: { id: $id }){\n                data ", "\n                error {\n                    code\n                    message\n                }\n            }\n        }\n    }\n"])), userFormFields(params));
};
var CREATE_USER = exports.CREATE_USER = (0, _graphqlTag.default)(_templateObject3 || (_templateObject3 = (0, _taggedTemplateLiteral2.default)(["\n    mutation CreateUser($data: AdminUsersCreateInput!){\n        adminUsers {\n            user: createUser(data: $data) {\n                data ", "\n                error {\n                    code\n                    message\n                    data\n                }\n            }\n        }\n    }\n"])), listUserFields);
var UPDATE_USER = exports.UPDATE_USER = function UPDATE_USER(params) {
  return (0, _graphqlTag.default)(_templateObject4 || (_templateObject4 = (0, _taggedTemplateLiteral2.default)(["\n    mutation UpdateUser($id: ID!, $data: AdminUsersUpdateInput!){\n        adminUsers {\n            user: updateUser(id: $id, data: $data) {\n                data ", "\n                error {\n                    code\n                    message\n                    data\n                }\n            }\n        }\n    }\n"])), userFormFields(params));
};
var DELETE_USER = exports.DELETE_USER = (0, _graphqlTag.default)(_templateObject5 || (_templateObject5 = (0, _taggedTemplateLiteral2.default)(["\n    mutation DeleteUser($id: ID!) {\n        adminUsers {\n            deleteUser(id: $id) {\n                data\n                error {\n                    code\n                    message\n                }\n            }\n        }\n    }\n"])));

//# sourceMappingURL=graphql.js.map